/*
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 */

package com.sun.mail.util;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import javax.mail.internet.SharedInputStream;

/**
 * SharedInputStream C^tF[X ByteArrayInputStream łB
 * {IȃoCgz񂪕̃[_ԂŋL̂܂B
 * 
 * @since JavaMail 1.2
 */
public final class SharedByteArrayInputStream extends ByteArrayInputStream implements SharedInputStream {

	protected int start = 0;

	/**
	 * RXgN^łB
	 */
	public SharedByteArrayInputStream(final byte[] buf) {
		super(buf);
	}

	/**
	 * RXgN^łB
	 */
	public SharedByteArrayInputStream(final byte[] buf, final int offset, final int length) {
		super(buf, offset, length);
		start = offset;
	}

	public long getPosition() {
		return pos - start;
	}

	public InputStream newStream(final long start, long end) {
		if (start < 0)
			throw new IllegalArgumentException("start < 0");
		if (end == -1)
			end = count - this.start;
		return new SharedByteArrayInputStream(buf, this.start + (int)start, (int)(end - start));
	}

}
