/*
 * Copyright 1997-2004 Sun Microsystems, Inc. All Rights Reserved.
 */

package javax.mail;

/**
 * Messaging NXɂX[SĂ̗O̊NXłB
 */
public class MessagingException extends Exception {

	private static final long serialVersionUID = 1L;

	/**
	 * `F[ꂽ̗OłB
	 *
	 * @serial
	 */
	private Exception next;

	/**
	 * ڍ׃bZ[Ww肵Ȃ MessagingException \z܂B
	 */
	public MessagingException() {
		super();
	}

	/**
	 * w肳ꂽڍ׃bZ[Wgp MessagingException \z܂B
	 * 
	 * @param s ڍ׃bZ[W
	 */
	public MessagingException(final String s) {
		super(s);
	}

	/**
	 * w肳ꂽ Exception Əڍ׃bZ[Wgp MessagingException \z܂B
	 * w肳ꂽO̗͂OɃ`F[܂B
	 * 
	 * @param s ڍ׃bZ[W
	 * @param e ߍ܂ꂽO
	 * @see #getNextException
	 * @see #setNextException
	 */
	public MessagingException(final String s, final Exception e) {
		super(s);
		next = e;
	}

	/**
	 * ̗OɃ`F[ꂽ̗O擾܂B
	 * ̗O MessagingException ̏ꍇA
	 * XɎ̃`F[Ăꍇ܂B
	 * 
	 * @return ̗OB݂Ȃꍇ null
	 */
	public synchronized Exception getNextException() {
		return next;
	}

	/**
	 * `F[̏I[ɗOǉ܂B
	 * I[ MessagingException <strong>Ȃ</strong>ꍇA
	 * ̗OIɒǉł܂B
	 *
	 * @param ex O`F[̐VI[
	 * @return ̗Oǉꂽꍇ <code>true</code>AłȂꍇ <code>false</code>
	 */
	public synchronized boolean setNextException(final Exception ex) {
		Exception theEnd = this;
		while (theEnd instanceof MessagingException &&
			((MessagingException)theEnd).next != null) {
			theEnd = ((MessagingException)theEnd).next;
		}
		// If the end is a MessagingException, we can add this 
		// exception to the chain.
		if (theEnd instanceof MessagingException) {
			((MessagingException)theEnd).next = ex;
			return true;
		}
		return false;
	}

	/**
	 * bZ[W𐶐܂B
	 * qɂꂽOꍇ́ÃbZ[W܂݂܂B
	 */
	public final String getMessage() {
		if (next == null)
			return super.getMessage();
		Exception n = next;
		String s = super.getMessage();
		StringBuffer sb = new StringBuffer(s == null ? "" : s);
		while (n != null) {
			sb.append(";\n  nested exception is:\n\t");
			if (n instanceof MessagingException) {
				MessagingException mex = (MessagingException) n;
				sb.append(n.getClass().toString());
				String msg = mex.getSuperMessage();
				if (msg != null) {
					sb.append(": ");
					sb.append(msg);
				}
				n = mex.next;
			} else {
				sb.append(n.toString());
				n = null;
			}
		}
		return sb.toString();
	}

	private String getSuperMessage() {
		return super.getMessage();
	}

}
